<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>
  <div class="container">
    <div class="text-center mt-2 mb-2">
      <h2>F120 - Quản trị Order</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="voucherCodeInput">Loại Pizza</label>
        </div>
        <div class="col-sm-6">
          <select id="gPizzaTypeSelect" class="form-control">
              
          </select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-order" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
    </div>

    <div class="container">
      <table class="table table-bordered table-striped table-hover" id="order-table">
        <thead>
          <tr>
            <th>STT</th>
            <th>Mã order</th>
            <th>Loại Pizza</th>
            <th>Tên khách hàng</th>
            <th>Ngày đặt hàng</th>
            <th>Trạng thái</th>
            <th>Action</th>
          </tr>
        </thead>
      </table>
    </div>

    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      // mảng orders
      var gOrderObjects = [
        {
          "id": 2,
          "orderCode": "12456",
          "gPizzaTypeId": 20,
          "customerName": "Do Van Linh",
          "date": "13/01/2021",
          "status": "completed"
        },
        {
          "id": 3,
          "orderCode": "22456",
          "gPizzaTypeId": 10,
          "customerName": "Huynh Van Nam",
          "date": "13/01/2021",
          "status": "new"
        },
        {
          "id": 4,
          "orderCode": "22986",
          "gPizzaTypeId": 15,
          "customerName": "Do Thi Lan",
          "date": "14/01/2021",
          "status": "completed"
        },
        {
          "id": 5,
          "orderCode": "42086",
          "gPizzaTypeId": 10,
          "customerName": "Dinh Chau Ngoc",
          "date": "14/01/2021",
          "status": "completed"
        },
        {
          "id": 6,
          "orderCode": "56086",
          "gPizzaTypeId": 15,
          "customerName": "Dang Tien Minh",
          "date": "15/01/2021",
          "status": "new"
        },
        {
          "id": 7,
          "orderCode": "90081",
          "gPizzaTypeId": 20,
          "customerName": "Do Hong Quan",
          "date": "15/01/2021",
          "status": "inprogress"
        },
        {
          "id": 8,
          "orderCode": "67012",
          "gPizzaTypeId": 15,
          "customerName": "Bui Thanh Phuoc",
          "date": "15/01/2021",
          "status": "inprogress"
        }
      ];

      // mảng pizza Type
      var gPizzaType = [
        {
          typeId: 10,
          typeName: "Hải Sản"
        },
        {
          typeId: 15,
          typeName: "Bò bít tết"
        },
        {
          typeId: 20,
          typeName: "Thịt gà"
        }
      ];
      
      const gUSER_COL = ['id', 'orderCode', 'gPizzaTypeId', 'customerName', 'date', 'status', 'action'];
      const gCOL_STT = 0;
      const gCOL_ORDERCODE = 1;
      const gCOL_PIZZA_ID = 2;
      const gCOL_CUSTOMER_NAME = 3;
      const gCOL_DATE = 4;
      const gCOL_STATUS = 5;
      const gCOL_ACTION = 6;
     
      
      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      
      onPageLoading();
      
      //thêm sự kiện cho nút filter
      $("#btn-filter-order").on("click", function () {
        onBtnFilterOrderClick();
      })
      
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      
      function onPageLoading() {
        "use strict";
        
        //mapping and load data to the table 
        $('#order-table').DataTable({
          data: gOrderObjects,
          columns: [
            { data: gUSER_COL[gCOL_STT] },
            { data: gUSER_COL[gCOL_ORDERCODE] },
            { data: gUSER_COL[gCOL_PIZZA_ID] },
            { data: gUSER_COL[gCOL_CUSTOMER_NAME] },
            { data: gUSER_COL[gCOL_DATE] },
            { data: gUSER_COL[gCOL_STATUS] },
            { data: gUSER_COL[gCOL_ACTION] },
          ],
          columnDefs: [
            
            {
              targets: gCOL_STT,
              className: "text-center",
              render: function (data, type, row, meta) {
              return meta.row + meta.settings._iDisplayStart + 1;
              }
            },
            {
              targets: gCOL_ACTION, 
              className: "text-center",
              defaultContent: `
                  <i title = 'Edit' class="fas fa-edit" style ="cursor:pointer; color:green;"></i> &nbsp; 
                  <i title = 'Delete' class="fas fa-trash" style ="cursor:pointer; color:red;"></i>
                  `
            }
          ]
        });
        loadDataToSelect(gPizzaType);
      }
      
   //hàm xử lý nút filter 
   function onBtnFilterOrderClick() {
        "use strict";
        //khai báo đối tượng chứa dữ liệu filter
        var vFilterPizzaType = {
          pizzaTypeId: 0
        };
        //B1 thu thập dữ liệu để filter
        getFilterFormData(vFilterPizzaType);
        //B2: validate (k cần)
        //B3: xử lý filter
        var vResultFilter = filterPizzaType(vFilterPizzaType);
        console.log(vResultFilter);
        //B4 hiển thị kết quả lọc
        DisplayOrderToTable(vResultFilter);

      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      // hàm trả về pizzaTypeName dựa vào typeId
      function getPizzaNameByTypeId(paramTypeId) {
        "use strict";
        var vPizzaTypeName = "";
        var vIndex = 0;
        var vIsTypeFound = false;
        while (!vIsTypeFound && vIndex < gPizzaType.length) {
          if (gPizzaType[vIndex].typeId === paramTypeId) {
            vIsTypeFound = true;
            vPizzaTypeName = gPizzaType[vIndex].typeName;
          }
          else {
            vIndex++;
          }
        }
        return vPizzaTypeName;
      }


      //hàm load dữ liệu select
      function loadDataToSelect(paramData) {
        "use strict";
        $("#gPizzaTypeSelect").append($("<option>", {
          text: "--- Chọn tất cả ---",
          value: 0
        }));

        for (var bI = 0; bI < paramData.length; bI++) {
          $("#gPizzaTypeSelect").append($("<option>", {
            text: paramData[bI].typeName,
            value: paramData[bI].typeId
          }));
        }
      }

      //hàm thu thập dữ liệu để lọc
      function getFilterFormData(paramFilterObj) {
        "use strict";
        paramFilterObj.pizzaTypeId = $("#gPizzaTypeSelect").val();
        console.log("Pizza type đã lọc là: " + paramFilterObj.pizzaTypeId);
      }


      //hàm thực hiện lọc và hiển thị lên table
      function filterPizzaType(paramFilterObj) {
        var vResult = [];
        //thực hiện lọc
        vResult = gOrderObjects.filter(function (paramOrder) {
          return (paramFilterObj.pizzaTypeId == 0 || paramOrder.gPizzaTypeId == paramFilterObj.pizzaTypeId);
        });

        return vResult;
      }



      //function to display the filter's result
      function DisplayOrderToTable(paramData) {
        "use strict";
        
        $('#order-table').DataTable().clear(); 
        $('#order-table').DataTable().rows.add(paramData); 
        $('#order-table').DataTable().draw();  

      }


    </script>
</body>

</html>

